--------------------------------------------------------------  
--  VIRT Version 2.0 Demo by Alexander Baranovsky
--  Subject : Cycled list application : addition of polynomials
--  Copyright (c) 1999 by A.Baranovsky
--------------------------------------------------------------

function Print( InitP )
  writeln( '' )
  P == InitP
  repeat
    writeln( STR( P[ 1, 1 ] ) + ' ' + STR( P[ 1, 2 ] ) )
    P == P[ 2 ]
  until P[ 1, 1 ] < 0
return 0

function Add( InitP, var InitQ )
  P == InitP
  Q == InitQ

  repeat

    while P[ 1, 1 ] < Q[ 1, 1 ] do
      Q == Q[ 2 ]
    end
  
    if    P[ 1, 1 ] > Q[ 1, 1 ] then   -- Insert after Q              
      Q == Q[ 2 ] 
      Q := [ P[ 1 ], << Q ]
    elsif P[ 1, 1 ] < 0 then 
      goto Fin
    else                               -- Combine coefficients        
      Q[ 1, 2 ] := P[ 1, 2 ] + Q[ 1, 2 ]
      if Q[ 1, 2 ] = 0 then            -- If 0 then to delete        
        [[ *, Q ]] << [ << Q ]
      else
        Q == Q[ 2 ]                    -- else skip
      end 
    end
  
    P == P[ 2 ]

  until FALSE

  label Fin

return 0

-------- Main program -----------------

  P := [[ -1,   0 ], == P ] 

  P := [[  70,  5 ], << P ]
  P := [[ 150,  6 ], << P ]
  P := [[ 600,  1 ], << P ]

  Q := [[ -1,   0 ], == Q ] 
  Q := [[  60,  5 ], << Q ]
  Q := [[ 150, -6 ], << Q ]
  Q := [[ 170,  3 ], << Q ] 
  Q := [[ 600,  1 ], << Q ]

  writeln( 'P' )
  Print( P )

  writeln( 'Q' )
  Print( Q ) 

  writeln( '' )

  Add( P, Q )

  writeln( 'Result' )

  Print( Q )
return
